---
title: 'Element: scroll event'
slug: Web/API/Element/scroll_event
tags:
  - API
  - Element
  - Event
  - Reference
  - Scroll
---
<p>{{APIRef}}</p>

<p>The <strong><code>scroll</code></strong> event fires an element has been scrolled.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("GlobalEventHandlers.onscroll", "onscroll")}}</td>
  </tr>
 </tbody>
</table>

<div class="notecard note">
<p><strong>Note:</strong> In iOS UIWebViews, <code>scroll</code> events are not fired while scrolling is taking place; they are only fired after the scrolling has completed. See <a href="https://github.com/twbs/bootstrap/issues/16202">Bootstrap issue #16202</a>. Safari and WKWebViews are not affected by this bug.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Scroll_event_throttling">Scroll event throttling</h3>

<p>Since <code>scroll</code> events can fire at a high rate, the event handler shouldn't execute computationally expensive operations such as DOM modifications. Instead, it is recommended to throttle the event using {{DOMxRef("Window.requestAnimationFrame()", "requestAnimationFrame()")}}, {{DOMxRef("WindowOrWorkerGlobalScope.setTimeout()", "setTimeout()")}}, or a {{DOMxRef("CustomEvent")}}, as follows.</p>

<p>Note, however, that input events and animation frames are fired at about the same rate, and therefore the optimization below is often unnecessary. This example optimizes the <code>scroll</code> event for <code>requestAnimationFrame</code>.</p>

<pre class="brush: js notranslate">// Reference: http://www.html5rocks.com/en/tutorials/speed/animations/

let last_known_scroll_position = 0;
let ticking = false;

function doSomething(scroll_pos) {
  // Do something with the scroll position
}

window.addEventListener('scroll', function(e) {
  last_known_scroll_position = window.scrollY;

  if (!ticking) {
    window.requestAnimationFrame(function() {
      doSomething(last_known_scroll_position);
      ticking = false;
    });

    ticking = true;
  }
});</pre>

<div class="notecard note">
<p><strong>Note</strong>: You can find more examples on the {{domxref("Document/resize_event", "resize")}} event page.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSSOM View', '#scrolling-events')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.scroll_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Document: {{domxref("Document/scroll_event", "scroll")}} event</li>
</ul>
